<?php
/**
 * Directory Listing Mod 03
 * Provided by: trustabyss.com
 */   
  

/** 
 * HTTP Gzip Compression
 * 
 * Allows you to compress the content before sending
 * it to the visitor's browser. This feature can make
 * the listing alot faster.
 * 
 * Set this to TRUE to enable Gzip Compression          
 */ 

 $enable_gzip = FALSE; 

/**
 * Directory Listing (MIME Types)
 *  
 * Set to TRUE to enable MIME Types display.  
 */
  
 $show_mimetypes = FALSE;

/** 
 * Directory Listing (Signature) 
 * 
 * Allows you to show the server information at the 
 * bottom of the Directory Listing. FALSE to disable.   
 */ 
 
 $server_sig = TRUE;  
 
/**  
 * Directory Listing (Signature Options)  
 *   
 * This setting allows you to controle what information   
 * will be displayed in the Directory Listing signature.  
 *   
 * Example:  
 *   
 * 1 (OS): Abyss/ver (OS) Server at Host Port   
 * 2 (Minor): Abyss/x.x Server at Host Port  
 * 3 (Minimal): Abyss/ver Server at Host Port  
 * 4 (Major): Abyss/x Server at Host Port  
 * 5 (Prod): Abyss Server at Host Port 
 */  
  
 $sig_options = 3; 
 
/**
 * Directory Listing (Time Format)
 * 
 * This setting allows you to choose the time format
 * for the Directory Listing. Set this value to FALSE
 * if you wish to use your local server time.
 * 
 * The default is set to TRUE to show only Greenwhich
 * Mean Time. You can change it if you like.
 */
  
 $show_gmt_date = TRUE;               
  

/**
 * Edit The Below Code At Your Own Risk!
 *                     
 * I cannot provide any support for the modifications  
 * of this code, so edit this code at your own risk.  
 */

 
ini_set("display_errors", 1); 
error_reporting("E_ALL & ~E_NOTICE");

 
if ($enable_gzip !== FALSE) {

    @ob_start("ob_gzhandler");
}

function GetTZOffset() {

    $iTime = time(); 
    $ar = localtime($iTime); 
    $ar[5] += 1900; 
    $ar[4]++;   
    $iTztime = gmmktime($ar[2], $ar[1], $ar[0], $ar[4], $ar[3], $ar[5]);  
    
    return($iTztime - $iTime); 
} 

$n = $_GET["n"]; 
$d = $_GET["d"]; 
$s = $_GET["s"]; 
$t = $_GET["t"];   

if (ereg("^/$", $_POST["path"])) { 
  
    $path = "/";  
} 
else {   

    $path = ereg_replace("/$", "", $_POST["path"]);  
} 
?><!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2 Final//EN"><html><head><title>Index of <?php echo(stripslashes($path)); ?></title></head><body><h1>Index of <?php echo(stripslashes($path)); ?></h1>
<?php  
$lines = explode("\n", $_POST["files"]);   

for ($b=0; $b < count($lines); $b++)  { 
 
    $array = explode("\t", $lines[$b]);    
    
    if (!ereg("^\.+", $array[$b])) { 

        $id[] = $b; 
        $name[] = $array[0];
        $url[] = $array[1];
        $size[] = $array[2];
        $date[] = $array[3];
        $type[] = $array[4];   
    }  
}  

$dir = array($name, $url, $size, $date, $type, $id);    

if ($n=="a") {

    $n_url = "n=d"; 
    $d_url = "d=a"; 
    $s_url = "s=a"; 
    $t_url = "t=a";     
    
    array_multisort($name, SORT_STRING, SORT_ASC, $dir[0], $dir[1], $dir[2], $dir[3], $dir[4], $dir[5]);   
}  
elseif ($n=="d") {   

    $n_url = "n=a"; 
    $d_url = "d=a"; 
    $s_url = "s=a"; 
    $t_url = "t=a";     
    
    array_multisort($name, SORT_STRING, SORT_DESC, $dir[0], $dir[1], $dir[2], $dir[3], $dir[4], $dir[5]);   
}  
elseif ($d=="a") {   

    $n_url = "n=a"; 
    $d_url = "d=d"; 
    $s_url = "s=a"; 
    $t_url = "t=a";     
    
    array_multisort($dir[3], SORT_STRING, SORT_ASC, $dir[1], $dir[2], $dir[0], $dir[4], $dir[5]);   
}  
elseif ($d=="d") {   

    $n_url = "n=a"; 
    $d_url = "d=a"; 
    $s_url = "s=a"; 
    $t_url = "t=a";     
    
    array_multisort($dir[3], SORT_STRING, SORT_DESC, $dir[1], $dir[2], $dir[0], $dir[4], $dir[5]);   
}  
elseif ($s=="a") {   

    $n_url = "n=a"; 
    $d_url = "d=a"; 
    $s_url = "s=d"; 
    $t_url = "t=a";     
    
    array_multisort($dir[2], SORT_NUMERIC, SORT_ASC, $dir[1], $dir[0], $dir[3], $dir[4], $dir[5]);   
}  
elseif ($s=="d") {   

    $n_url = "n=a"; 
    $d_url = "d=a"; 
    $s_url = "s=a"; 
    $t_url = "t=a";     
    
    array_multisort($dir[2], SORT_NUMERIC, SORT_DESC, $dir[1], $dir[0], $dir[3], $dir[4], $dir[5]);   
}  
elseif ($t=="a") {   

    $n_url = "n=a"; 
    $d_url = "d=a"; 
    $s_url = "s=a"; 
    $t_url = "t=d";     
    
    array_multisort($dir[4], SORT_STRING, SORT_ASC, $dir[1], $dir[2], $dir[3], $dir[0], $dir[5]);   
}  
elseif ($t=="d") {   

    $n_url = "n=a"; 
    $d_url = "d=a"; 
    $s_url = "s=a"; 
    $t_url = "t=a";     
    
    array_multisort($dir[4], SORT_STRING, SORT_DESC, $dir[1], $dir[2], $dir[3], $dir[0], $dir[5]);   
}  
else {   

    $n_url = "n=d"; 
    $d_url = "d=a"; 
    $s_url = "s=a"; 
    $t_url = "t=a";     
    
    array_multisort($name, SORT_STRING, SORT_ASC, $dir[0], $dir[1], $dir[2], $dir[3], $dir[4], $dir[5]);   
} 
?>
<pre><img src="/icons/blank.gif" alt=""> <a href="<?php echo("?$n_url"); ?>">Name</a>                    <a href="<?php echo("?$d_url"); ?>">Last modified</a>      <a href="<?php echo("?$s_url"); ?>">Size</a>  <a href="<?php echo("?$t_url"); ?>">Description</a><hr><?php
if ($_POST["path"] != "/") {

    echo "<img src=\"/icons/back.gif\"> <a href=\"../\">Parent Directory</a>" . "                             -" . "\n";
}

$TZOffset = GetTZOffset(); 
$host  = $_SERVER["HTTP_HOST"]; 
$port  = $_SERVER["SERVER_PORT"];
$serv  = $_SERVER["SERVER_SOFTWARE"]; 
$host  = explode(":", $host); 
$token = explode("-", $serv); 
$os = explode(" ", $token[2]);

for ($n=0; $n < count($dir[0]); $n++) {

    $name = stripslashes($dir[0][$n]); 
    $url  = stripslashes($dir[1][$n]);
    
    $size = $dir[2][$n]; 
    $date = $dir[3][$n]; 
    $mimetype = $dir[4][$n];

    if ($size < 1024) {

        $size = $size . " ";
    }
    elseif ($size < 1048576) {

        $format = "K"; 
        $num  = $size/1024; 
        $size = round($num, 1) . $format;
    }
    elseif ($size < 1073741824) {

        $format = "M"; 
        $num  = $size/1048576; 
        $size = round($num, 1) . $format;
    }
    elseif ($size >= 1073741824) {

        $format = "G"; 
        $num  = $size/1073741824; 
        $size = round($num, 1) . $format;
    }
    
    if (strlen($size) > 4) {

        $size = round(substr($size, 0, 4)) . $format;

        if (strlen($size) < 4) {
    
            $space = "    " . $size; 
            $size = substr($space, strlen($space)-4, 4);
        }
    }
    else {

        $space = "    " . $size; 
        $size = substr($space, strlen($space)-4, 4);
    }

    if (strlen($name) > 23) {

        $name  = substr($name, 0, 20); 
        $name .= "..>";
    }

    if ($show_gmt_date !== FALSE) {
    
        $date = date("d-M-Y H:i", strtotime($date));
    }
    else {
    
        $date = date("d-M-Y H:i", strtotime($date) + $TZOffset);
    }

    $hidden = "^listing\.php$";

    if (!eregi($hidden, $url)) {
          
        if (eregi("^text/", $mimetype)) {
    
            $ico = "text.gif";
        }
        elseif (eregi("^image/", $mimetype)) {
    
            $ico = "image2.gif";
        }
        elseif (eregi("^audio/", $mimetype)) {
    
            $ico = "sound2.gif";
        }
        elseif (eregi("^video/", $mimetype)) {
    
            $ico = "movie.gif";
        }
        elseif (eregi("\.(bin|exe)$", $url)) {
    
            $ico = "binary.gif";
        }
        elseif (eregi("\.hqx$", $url)) {
    
            $ico = "binhex.gif";
        }
        elseif (eregi("\.tar$", $url)) {
    
            $ico = "tar.gif";
        }
        elseif (eregi("\.(Z|z|tgz|gz|zip)$", $url)) {
    
            $ico = "compressed.gif";
        }
        elseif (eregi("\.uu$", $url)) {
    
            $ico = "uu.gif";
        }
        else {
    
            $ico = "unknown.gif";
        }

        $space = "                        "; 
        $space = substr($space, strlen($name), strlen($space)-strlen($name));

        if ($mimetype == "") {
    
            $mimetype = "Directory";

            if ($show_mimetypes !== TRUE) {
    
                $mimetype = "";
            }

            echo "<img src=\"/icons/folder.gif\" alt=\"\"> " . "<a href=\"$url\">$name</a>"  . $space  . $date . " " . $time . "   -" . "   " . $mimetype . "\n";  
        }
        else {

            if ($show_mimetypes !== TRUE) {
    
                $mimetype = "";
            }

            echo "<img src=\"/icons/$ico\" alt=\"\"> " . "<a href=\"$url\">$name</a>"  . $space  . $date . " " . $time . " $size" . "  " . $mimetype . "\n";
        }

    }
}

if ($server_sig !== FALSE) {

    switch ($sig_options) {
    
        case "1":
        
            $signature = "$token[0] ($os[0]) Server at $host[0] Port $port";
            break;

        case "2":
        
            $signature = substr($token[0], 0, 9) . " Server at $host[0] Port $port";
            break;

        case "3":
        
            $signature = "$token[0] Server at $host[0] Port $port";
            break;

        case "4":
        
            $signature = substr($token[0], 0, 7) . " Server at $host[0] Port $port";
            break;

        case "5":
        
            $signature = substr($token[0], 0, 5) . " Server at $host[0] Port $port";
            break;

        default:
        
            $signature = "$token[0] Server at $host[0] Port $port";
            break;
    }
}
else {

    $signature = "";
}

echo "<hr></pre><address>$signature</address></body></html>"; 
?>